<?php
/*  Copyright (C)2012 byMike <m at byMike.ch>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/**
 * Description of eventsbymike_controller_shortcodes
 *
 * @author byMike <m at byMike.ch>
 * 
 */
class eventsbymike_controller_shortcodes extends wpbymike_controller
{
    public function ebm_dates($atts) {
            extract( shortcode_atts( array(
                    'type' => 'all',
                    'limit' => 0,
                    'order' => 'ASC'
            ), $atts ) );
            
            // Check Attributes
            if ($order == 'DESC')
                $order = 'DESC';
            else
                $order = 'ASC';
            
            // get the model
            $datesModel = new eventsbymike_model_date($this->pluginReference);

            // Get the Dates
            if (strtolower($type) == 'upcoming') {
                $dates = $datesModel->getAllInFuture('array', $limit);
            } else {
                $dates = $datesModel->getAll('array', $limit, $order);
            }
            
            // Check for Results
            if (is_array($dates)) {
                // Get Post from Date
                // Limit DB Querries
                $posts = array();
                for ($i=0;$i<count($dates);$i++) {
                    if (isset( $posts[ ($dates[$i]['post_id']) ]))
                        $dates[$i]['post'] = $posts[ ($dates[$i]['post_id']) ];
                    else $dates[$i]['post'] = get_post($dates[$i]['post_id']);
                }
                unset($posts);
                unset($i);
                // Register to View
                $this->view()->registerVar('dates', $dates);
            } else {
                $this->view()->registerVar('dates', array());
            }
            
            
            // Render View
            
            return $this->view()->render('showEvents.php',FALSE,TRUE);
            
            
        }
        
        public function ebm_vita($atts) {
            extract( shortcode_atts( array(
                    'limit' => 0,
                    'order' => 'DESC'
            ), $atts ) );
            
            // Check Attributes
            if (!is_int($limit) || $limit <= 0)
                $limit = 0;
            if ($order == 'ASC')
                $order = 'ASC';
            else
                $order = 'DESC';
            
            // get the model
            $datesModel = new eventsbymike_model_date($this->pluginReference);

            // Get the Dates
            $dates = $datesModel->getVita('array', $limit, $order);
            
            // Check for Results
            if (is_array($dates)) {
                // Get Post from Date
                // Limit DB Querries
                $posts = array();
                for ($i=0;$i<count($dates);$i++) {
                    if (isset( $posts[ ($dates[$i]['post_id']) ]))
                        $dates[$i]['post'] = $posts[ ($dates[$i]['post_id']) ];
                    else $dates[$i]['post'] = get_post($dates[$i]['post_id']);
                }
                unset($posts);
                unset($i);
                // Register to View
                $this->view()->registerVar('dates', $dates);
            } else {
                $this->view()->registerVar('dates', array());
            }
            
            // Render View
            
            return $this->view()->render('showVita.php', FALSE, TRUE);
            
            
        }
}

// EoC eventsbymike_controller_shortcodes