<?php

/*  Copyright (C)2012 byMike <m at byMike.ch>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/**
 * Basic Class Functions baseclass
 *
 * @author byMike <m at byMike.ch>
 * 
 */
class wpbymike_baseClass {
    
    protected $config = array();
    
    /**
     * Set Config Value: option => value
     * @param string/arraymap $option
     * @param type $optVal 
     */
    public function setOption ($option, $optVal = '') {
        if (is_array($option)) 
            $this->config = array_merge ($this->config, $option);
        else
            $this->config[$option] = $optVal;
    }
    
    /**
     * Set Config Values from ArrayMap (option => value)
     * @param type $arrayMap 
     */
    public function setOptions($arrayMap) {
        if(is_array($arrayMap))
            $this->setOption ($arrayMap);
    }
    
    /**
     * Get Config Option by Key
     * @param string $option
     * @return boolean 
     */
    public function getOption($option) {
        if (isset($this->config[$option]))
            return $this->config[$option];
        else
            return FALSE;
    }
    
    /**
     * Get Configuration Array
     * @return array $config 
     */
    public function getOptions() {
        return $this->config;
    }
    
}

// EoC baseclass