<?php

/*  Copyright (C)2012 byMike <m at byMike.ch>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/**
 * Description of wpbymike_controller
 *
 * @author byMike <m at byMike.ch>
 * 
 */
abstract class wpbymike_controller
{
    
    protected $pluginReference = NULL;
    
    protected $viewObj = NULL;


    /**
     * Subcontroller construct
     * @param wpbymike_plugin $pluginReference 
     */
    public function __construct (wpbymike_plugin $pluginReference) {
        $this->pluginReference = $pluginReference;
        $this->init();
    }
    
    /**
     * Runs with Constructor
     */
    public function init() {
        return;
    }

    /**
     * Get the View Object
     * 
     * @param array $config
     * @return \wpbymike_view object 
     */
    public function view($config = array()) {
        if (is_null($this->viewObj)) {
            $this->viewObj = new wpbymike_view ($this->pluginReference->getOptions());
            $this->viewObj->setOptions($config);

            // Register Std ViewVars
            // Plugin Information
            $this->viewObj->registerVars( array(
                'pluginDir' => $this->pluginReference->pluginDir,
                'pluginDirUrl' => $this->pluginReference->pluginDirUrl,
                'pluginName' => $this->pluginReference->pluginName
            ));

            // Set Controller Instance
            $this->viewObj->setController($this->pluginReference);




        }

        return $this->viewObj;

    }

    
}

// EoC wpbymike_controller