<?php

/*  Copyright (C)2012 byMike <m at byMike.ch>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/**
 * A Basic Set of Filters to Validate MySQL Entries
 * 
 * Singleton Object
 *
 * @author byMike <m at byMike.ch>
 * 
 */
class wpbymike_filter_mysql {
    
    /**
    * Check a Date
    * @param string $dateval
    * @return boolean 
    */
    public static function checkdate( $dateval = '' ) {

        if (preg_match('/^([0-9]{4})-([0][0-9]|1[0-2])-([0-2][0-9]|3[0-1])/', $dateval)) {

            $dateMap = explode('-', $dateval);

            if (checkdate($dateMap[1], $dateMap[2], $dateMap[0])) {
                return TRUE;
            }

        }

        return FALSE;

    }
    
    /**
     * check a TimeValue
     * @param string $timeval
     * @return boolean
     */
    public static function checktime( $timeval = '' ) {
        
        if (preg_match('/^([01]?[0-9]|2[0-3]):[0-5][0-9]/', $timeval))
            return TRUE;
        else
            return FALSE;
    }
}

// EoC wpbymike_filter_mysql